﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Xaml.Shapes;


// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641

namespace ComboUnlock
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {


        private List<int> iGivPassword;
        private List<int> iSetPassword;

        private int iLastNum;

        Windows.UI.Color myBlue = Windows.UI.Color.FromArgb(0xFF, 0x00, 0x78, 0xD7);
        Windows.UI.Color myGray = Windows.UI.Color.FromArgb(0xFF, 0x76, 0x76, 0x76);

        public MainPage()
        {
            this.InitializeComponent();

            this.NavigationCacheMode = NavigationCacheMode.Required;

            iGivPassword = new List<int>();
            iSetPassword = new List<int>();

            SetPassword();

            iLastNum = 0;

            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item1_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item2_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item3_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item4_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item5_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item6_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item7_PointerEntered), true);
            AddHandler(UIElement.PointerEnteredEvent, new PointerEventHandler(Item8_PointerEntered), true);
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // TODO: Prepare page for display here.

            // TODO: If your application contains multiple pages, ensure that you are
            // handling the hardware Back button by registering for the
            // Windows.Phone.UI.Input.HardwareButtons.BackPressed event.
            // If you are using the NavigationHelper provided by some templates,
            // this event is handled for you.
        }

        private void SetPassword()
        {
            iSetPassword.Clear();
            iSetPassword.Add(1);
            iSetPassword.Add(2);
            iSetPassword.Add(3);
            iSetPassword.Add(6);
            iSetPassword.Add(7);
            iSetPassword.Add(6);
        }

        private void AddNumber( int iNewNum )
        {
            if (iGivPassword.Count == iSetPassword.Count)
                iGivPassword.RemoveAt(0);

            iGivPassword.Add( iNewNum );
            iLastNum = iNewNum;
        }

        private void Unlock()
        {
            Canvas.SetZIndex(BackgroundImage, 5);

            BackgroundImage.Source = new BitmapImage(new Uri("ms-appx:///Assets/UnlockedScreen.png", UriKind.Absolute));
        }

        private void TryUnlock()
        {
            if (iGivPassword.Count == iSetPassword.Count)
            {
                for (int iIndex = 0; iIndex < iSetPassword.Count; iIndex++)
                {
                    if (iSetPassword[iIndex] != iGivPassword[iIndex])
                        return;
                }

                Unlock();
            }
        }

        private void TurnOn( TextBlock tb )
        {
            tb.Foreground = new SolidColorBrush(myBlue);
            tb.FontWeight = Windows.UI.Text.FontWeights.Bold;
        }

        private void TurnOn(Rectangle rec)
        {
            rec.Opacity = 1;
        }

        private void TurnOff(TextBlock tb)
        {
            tb.Foreground = new SolidColorBrush(myGray);
            tb.FontWeight = Windows.UI.Text.FontWeights.Normal;
        }

        private void TurnOff( Rectangle rec )
        {
            if (rec.Name == "TrackCenter")
                rec.Opacity = 0;
            else
                rec.Opacity = .55;
        }

        private void Item1_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 1) || (iLastNum == 5) || (iLastNum == 7))
                return;

            TurnOff(Item1);
            TurnOn(Item2);
            TurnOn(Item3);
            TurnOn(Item4);
            TurnOff(Item5);
            TurnOn(Item6);
            TurnOff(Item7);
            TurnOn(Item8);

            TurnOn(TrackTopLeftD);
            TurnOn(TrackBottomLeftD);
            TurnOn(TrackTopRightD);
            TurnOn(TrackBottomRightD);
            TurnOn(TrackCenter);

            TurnOn(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOn(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(1);

            TryUnlock();
        }

        private void Item2_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 2) || (iLastNum == 4) || (iLastNum == 5) || (iLastNum == 6) || (iLastNum == 7) || (iLastNum == 8))
                return;

            TurnOn(Item1);
            TurnOff(Item2);
            TurnOn(Item3);
            TurnOff(Item4);
            TurnOff(Item5);
            TurnOff(Item6);
            TurnOff(Item7);
            TurnOff(Item8);

            TurnOff(TrackTopLeftD);
            TurnOff(TrackBottomLeftD);
            TurnOff(TrackTopRightD);
            TurnOff(TrackBottomRightD);
            TurnOff(TrackCenter);

            TurnOn(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOn(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(2);

            TryUnlock();
        }

        private void Item3_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 3) || (iLastNum == 4) || (iLastNum == 7))
                return;

            TurnOn(Item1);
            TurnOn(Item2);
            TurnOn(Item3);
            TurnOff(Item4);
            TurnOn(Item5);
            TurnOn(Item6);
            TurnOff(Item7);
            TurnOn(Item8);

            TurnOn(TrackTopLeftD);
            TurnOn(TrackBottomLeftD);
            TurnOn(TrackTopRightD);
            TurnOn(TrackBottomRightD);
            TurnOn(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOn(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOn(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(3);

            TryUnlock();
        }

        private void Item4_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 4) || (iLastNum == 2) || (iLastNum == 3) || (iLastNum == 5) || (iLastNum == 7) || (iLastNum == 8))
                return;

            TurnOn(Item1);
            TurnOff(Item2);
            TurnOff(Item3);
            TurnOff(Item4);
            TurnOff(Item5);
            TurnOn(Item6);
            TurnOff(Item7);
            TurnOff(Item8);

            TurnOff(TrackTopLeftD);
            TurnOff(TrackBottomLeftD);
            TurnOff(TrackTopRightD);
            TurnOff(TrackBottomRightD);
            TurnOff(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOn(TrackTopLeftV);
            TurnOn(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(4);

            TryUnlock();
        }

        private void Item5_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 5) || (iLastNum == 1) || (iLastNum == 2) || (iLastNum == 4) || (iLastNum == 6) || (iLastNum == 7))
                return;

            TurnOff(Item1);
            TurnOff(Item2);
            TurnOn(Item3);
            TurnOff(Item4);
            TurnOff(Item5);
            TurnOff(Item6);
            TurnOff(Item7);
            TurnOn(Item8);

            TurnOff(TrackTopLeftD);
            TurnOff(TrackBottomLeftD);
            TurnOff(TrackTopRightD);
            TurnOff(TrackBottomRightD);
            TurnOff(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOn(TrackTopRightV);
            TurnOn(TrackBottomRightV);

            AddNumber(5);

            TryUnlock();
        }

        private void Item6_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 6) || (iLastNum == 2) || (iLastNum == 5))
                return;

            TurnOn(Item1);
            TurnOff(Item2);
            TurnOn(Item3);
            TurnOn(Item4);
            TurnOff(Item5);
            TurnOff(Item6);
            TurnOn(Item7);
            TurnOn(Item8);

            TurnOn(TrackTopLeftD);
            TurnOn(TrackBottomLeftD);
            TurnOn(TrackTopRightD);
            TurnOn(TrackBottomRightD);
            TurnOn(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOn(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOff(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOn(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(6);

            TryUnlock();
        }

        private void Item7_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 7) || (iLastNum == 1) || (iLastNum == 2) || (iLastNum == 3) || (iLastNum == 4) || (iLastNum == 5))
                return;

            TurnOff(Item1);
            TurnOff(Item2);
            TurnOff(Item3);
            TurnOff(Item4);
            TurnOff(Item5);
            TurnOn(Item6);
            TurnOff(Item7);
            TurnOn(Item8);

            TurnOff(TrackTopLeftD);
            TurnOff(TrackBottomLeftD);
            TurnOff(TrackTopRightD);
            TurnOff(TrackBottomRightD);
            TurnOff(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOn(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOn(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOff(TrackBottomRightV);

            AddNumber(7);

            TryUnlock();
        }

        private void Item8_PointerEntered(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            if ((iLastNum == 8) || (iLastNum == 2) || (iLastNum == 4))
                return;

            TurnOn(Item1);
            TurnOff(Item2);
            TurnOn(Item3);
            TurnOff(Item4);
            TurnOn(Item5);
            TurnOn(Item6);
            TurnOn(Item7);
            TurnOff(Item8);

            TurnOn(TrackTopLeftD);
            TurnOn(TrackBottomLeftD);
            TurnOn(TrackTopRightD);
            TurnOn(TrackBottomRightD);
            TurnOn(TrackCenter);

            TurnOff(TrackTopLeftH);
            TurnOff(TrackBottomLeftH);
            TurnOff(TrackTopRightH);
            TurnOn(TrackBottomRightH);

            TurnOff(TrackTopLeftV);
            TurnOff(TrackBottomLeftV);
            TurnOff(TrackTopRightV);
            TurnOn(TrackBottomRightV);

            AddNumber(8);

            TryUnlock();
        }
    }
}
